//+------------------------------------------------------------------+
//|                                     Spencer's moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int  Price=PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double weights[]={-3,-6,-5,3,21,46,67,74,67,46,21,3,-5,-6,-3};

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,buffer1); SetIndexDrawBegin(0,7);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,7),Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double sum  = weights[7]*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = weights[7];
      for(int j=1; j<=7; j++)
      {
         sum  += weights[7-j]*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
         sumw += weights[7-j];

         if (j<=i)
         {
            sum  += weights[7+j]*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
            sumw += weights[7+j];
         }
      }
      buffer1[i] = sum/sumw;
   }            
   return(0);
}